/*
 * Arnold API header file
 * Copyright (c) 1998-2009 Marcos Fajardo, (c) 2009-2013 Solid Angle SL
 */

/**
 * \file
 * Various useful constants
 */

#pragma once

/** \defgroup ai_constants Constants
 * \{
 */

/**
 * \name Numerical Constants
 * \{
 */
#define AI_PI                 (3.1415926535897931f)   /**< pi                      */
#define AI_PITIMES2           (6.2831853071795862f)   /**< 2 * pi                  */
#define AI_PIOVER2            (1.5707963267948966f)   /**< pi / 2                  */
#define AI_ONEOVERPI          (0.3183098861837906f)   /**< 1 / pi                  */
#define AI_ONEOVER2PI         (0.1591549430918953f)   /**< 1 / 2pi                 */
#define AI_E                  (2.7182818284590452f)   /**< e                       */
#define AI_LOG2E              (1.4426950408889634f)   /**< log_2(e)                */
#define AI_SQRT2              (1.4142135623730951f)   /**< sqrt(2)                 */
#define AI_SQRT3              (1.7320508075688772f)   /**< sqrt(3)                 */
#define AI_GOLDEN             (1.6180339887498948f)   /**< Golden ratio            */
#define AI_DTOR               (0.0174532925199433f)   /**< Degrees to radians      */
#define AI_RTOD               (57.295779513082323f)   /**< Radians to degrees      */

#define AI_EPSILON            (1.0e-4f)              /**< System epsilon value    */
#define AI_BIG                (1.0e12f)              /**< Big number              */
#define AI_INFINITE           (1.0e30f)              /**< Our convention for an "infinite" number */
/* \}*/

/*\}*/
